/*
 * Auswertung von ASCII-Dateien nach Haeufigkeit
 *
 * Copyright (c)2007, by Dipl.-Inform, Dipl.-Ing. (FH) Michael Wilhelm
 * All Rights Reserved
 * 
 *
 * Michael Wilhelm, mwilhelm@hs-harz.de
 * Internet  :  mwilhelm.hs-harz.de
 */

import std.stdio;
import std.stream;
import std.string;

// Analyse der Verteilung der Buchstaben einer Datei
void  check_and_draw(char [] sFile) {
  int abc[26];
  char ch;
  int code;
  if ( !std.file.exists(sFile) ) {
    writefln("Datei %s ist nicht vorhanden: \n",sFile);
    return;
  }
  // komplett im Buffer des BS
  auto f = new BufferedFile(sFile);
  while (!f.eof()) {
     // Zeichenweise lesen
    f.read(ch);
    code = cast(int) ch;   // Cast nach int
    // A=65 das Charakter wird in einen Ascii-Code umgewandelt
    // Nur die A..Z und a..z werden betrachtet
    if ( (code>=65) && (code<=90) ) {
       abc[ code-65] ++;
    }
    if ( (code>=97) && (code<=122) ) {
       abc[ code-97] ++;
    }
     
  } // while
   // Ausgabe, entweder normal oder mit expandtabs
  writefln("Datei %s\n",sFile);
  foreach (int i, int value; abc) {
   ch = cast(char) (i+65);
   if (false) {
     writefln("%d  %s: %d",i,ch, value); // 17  R: 3248
   }
   else {
     char s[] = toString(i) ~ "\t" ~ ch ~ ":\t" ~ toString(value);
     writefln( "%s",expandtabs(s,7) );
   }
  }
  writefln("\n\n");
}  // check / draw

int main (char[][] args) {
   char [] sFile1 = "Texte\\Deutsch1.txt";
   char [] sFile2 = "Texte\\Englisch1.txt";
   char [] sFile3 = "Texte\\Latein1.txt";

  check_and_draw(sFile1);
  check_and_draw(sFile2);
  check_and_draw(sFile3);


  return 0;
}

